﻿Imports Scheduler
Imports HomeSeerAPI
Imports HSCF.Communication.Scs.Communication.EndPoints.Tcp
Imports HSCF.Communication.ScsServices.Client
Imports HSCF.Communication.ScsServices.Service
Imports System.Reflection
Imports System.Configuration
Imports System.Convert
Imports System.Net.Mail

''
''
'' tenScripting3 Changes
''
'' Version 3.26
''
''     Added Option to skip Event registration (HsEvents)
''
''     Added parameter parsing to NewScript snippet
''
'' Version 3.25
''
''     Link to tenScriptAid on Help Menu and tenScriptAid Button
''
''     Additional HS3 Code Snippets
''
''     Eliminate warning for unreferenced variable
''
'' Version 3.24
''
''     Added HS3 Code Snippets 
''
''     Added Retrieve Button for HS3 log
''
''
''  Version 3.23
''
''    More checking the export folder ends in "\"
''
''    After Export, checks the LastModifiedDate of the target file to verify it really copied
''
''    Eliminated from Connection Dialog:  Port, Userid, Password
''
''        Retrieves the Web Server Port from settings.ini
''
''    Updated links to new web locations for HS3 documentation
''
''    Changed termination logic once again
''
''    Eliminated exception if clicking COPY buttons with no text selected
''
''    Added Instance processing in hopes of improving event tracking after restart
''
Delegate Sub UpdateDevicesDelegate(ByVal p As String)
Public Class tenScripting
    Public WithEvents client As HSCF.Communication.ScsServices.Client.IScsServiceClient(Of IHSApplication)
    Dim WithEvents clientCallback As HSCF.Communication.ScsServices.Client.IScsServiceClient(Of IAppCallbackAPI)
    Private host As HomeSeerAPI.IHSApplication
    Public plugin As HSPI                               ' real plugin functions, user supplied
    Friend FreezeEvents As Boolean = False
    Friend FreezeLog As Boolean = False
    Friend ScriptingLog As Boolean = False
    Friend ScriptTable As ArrayList
    Friend DebugLogProccess As Process

    Private Sub frmMain_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        StartupComplete = False
        tmrStartup.Start()
    End Sub

    Private Sub client_Disconnected(ByVal sender As Object, ByVal e As System.EventArgs) Handles client.Disconnected
        HSPI.bShutDown = True
        Console.WriteLine("client_Disconnected:  tenScripting has been disconnected from HS3")
    End Sub

    Private Sub wait(ByVal secs As Integer)
        Threading.Thread.Sleep(secs * 1000)
    End Sub

    Private Sub tmrStartup_Tick(sender As System.Object, e As System.EventArgs) Handles tmrStartup.Tick
        Dim Config As System.Configuration.Configuration
        Dim ConfigFilePath As String
        Dim TerminatingForm As frmTerminating

        tmrStartup.Stop()
        ''
        '' Handle All Program Initialization in Timer Event, After frmMain has loaded
        ''
        ''
        ''     First, Connect to HS3
        ''
        Dim sIp, p As String, rc As Boolean
        Dim Attempts As Integer
        '' Do some initialization stuff before attempting connection
        MyLog("tenScripting Starting")
        Instance = "T" & Format(Now, "hhmmss")
        '' Upgrade Settings from Last Release if this is a New Release
        If My.Settings.UpgradeSettings Then
            My.Settings.Upgrade()
            My.Settings.UpgradeSettings = False
            My.Settings.Save()
            MyLog("New Version Detected.  Settings copied from prior version.")
        End If
        '' Get Location of Settings File 
        Config = System.Configuration.ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.PerUserRoamingAndLocal)
        ConfigFilePath = Config.FilePath
        MyLog("tenScripting3 Configuaration Settings stored in folder:")
        MyLog("    " & ConfigFilePath)
        theMainForm = Me
        Me.lblDeviceName.Text = ""
        chkProcessAsHsParms.Checked = My.Settings.ProcessAsHsParms
        My.Settings.TriggersEnabled = False : My.Settings.Save()
        Me.chkTriggers.Checked = My.Settings.TriggersEnabled
        Me.btnTriggers.Visible = Not My.Settings.TriggersEnabled
        '' See if we can find tenScriptAid location
        btnRunTenScriptAid.Visible = False
        If System.IO.File.Exists(SavedLocation) Then
            p = System.IO.File.ReadAllText(SavedLocation, System.Text.Encoding.ASCII)
            If System.IO.File.Exists(p) Then
                Me.btnRunTenScriptAid.Visible = True
            End If
        End If
        Me.chkSkipEvents.Checked = My.Settings.SkipEvents
        If My.Settings.SkipEvents Then
            lstChanges.Items.Add(">>> Skip Events has been requested <<<")
            lstHomeseerLog.Items.Add(">>> Skip Events has been requested <<<")
            MyLog(">>> Skip Events has been requested <<<")
        End If
        '' Now, let's see if we can connect
        sIp = My.Settings.HsComputer
        MyLog("Plugin: " & IFACE_NAME & " Instance: " & Instance & " starting...")
        AboutTenScripting010ToolStripMenuItem.Text = "About   tenScripting v" & Version()
        plugin = New HSPI
        client = ScsServiceClientBuilder.CreateClient(Of IHSApplication)(New ScsTcpEndPoint(sIp, 10400), plugin)
        clientCallback = ScsServiceClientBuilder.CreateClient(Of IAppCallbackAPI)(New ScsTcpEndPoint(sIp, 10400), plugin)
        Attempts = 1
TryAgain:
        Try
            MyLog("Connecting to server at " & sIp & "...")
            client.Connect()
            clientCallback.Connect()
            host = client.ServiceProxy
            Dim APIVersion As Double = host.APIVersion  ' will cause an error if not really connected
            Console.WriteLine("client ApiVersion: " & APIVersion.ToString)
            callback = clientCallback.ServiceProxy
            APIVersion = callback.APIVersion  ' will cause an error if not really connected
            Console.WriteLine("callback ApiVersion: " & APIVersion.ToString)
        Catch ex As Exception
            Console.WriteLine("Cannot connect attempt " & Attempts.ToString & ": " & ex.Message)
            MyLog("Cannot connect attempt " & Attempts.ToString & ": " & ex.Message)
            If ex.Message.ToLower.Contains("timeout occurred.") Then
                Attempts += 1
                If Attempts < 3 Then GoTo TryAgain
            End If
            frmConnection.ShowDialog()
            If client IsNot Nothing Then
                client.Dispose()
                client = Nothing
            End If
            If clientCallback IsNot Nothing Then
                clientCallback.Dispose()
                clientCallback = Nothing
            End If
            wait(4)
            Return
        End Try
        Try
            ' connect to HS so it can register a callback to us
            rc = host.Connect(IFACE_NAME, Instance)
            Console.WriteLine("host connect result: " & rc.ToString)
            ' create the user object that is the real plugin, accessed from the pluginAPI wrapper
            callback = callback
            hs = host
            MyLog("Connected, waiting to be initialized...")
        Catch ex As Exception
            MyLog("Cannot connect(2): " & ex.Message)
            wait(2)
            End
            Return
        End Try
        ''
        '' Connected, Finish tenScripting Initialization
        ''
        '' Set up Triggers data
        Console.WriteLine("Getting Triggers")
        GetTriggers()
        '' Gather information about scripts
        Console.WriteLine("Getting Scripts")
        GetScripts()        ' Find all Script.vb files in the Project Folder
        GetProjectFiles()   ' Find all of the files that will be compiled by Visual Studio   (for error checking)
        Me.btnTriggers.Visible = True
        Me.MenuStrip1.Visible = True
        '' Turn HS Debug Logging ON ?
        If My.Settings.DebugLoggingEnabled Then
            DeleteDebugLog()
            hs.DebugMode = 15
            Me.btnDebugLogs.Visible = True
        End If
        'hsp = CType(hs.GetHSPRef, Scheduler.hsp)            'HS Phone
        MyLog("Homeseer Connection Successful")
        Me.lblConnected.Text = "Connected"
        Me.picHS.Visible = True
        Me.Refresh()
        Me.btnRunSubMain.Enabled = True
        StartupComplete = True
        MyLog("tenScripting Initialization Complete")
        hs.WriteLog("tenScripting", "tenScripting" & ":" & Instance & " Started")
        ''
        '' Wait for tenScripting to Finish
        ''
        Console.WriteLine("Waiting for tenScripting to exit")
        Do
            Threading.Thread.Sleep(10)
            Application.DoEvents()
        Loop While client.CommunicationState = HSCF.Communication.Scs.Communication.CommunicationStates.Connected And Not HSPI.bShutDown
        Console.WriteLine("bShutDown now True, complete termination Of tenScripting")
        TerminatingForm = New frmTerminating
        TerminatingForm.Show()
        TerminatingForm.Refresh()
        Application.DoEvents()
        Console.WriteLine("Connection to HS3 lost, tenScripting is exiting")
        Console.WriteLine("HSPI.bshutDown=" & HSPI.bShutDown.ToString)
        ' disconnect from server for good here
        wait(2)
        Console.WriteLine("Disconnecting from HS3")
        client.Disconnect()
        clientCallback.Disconnect()
        Do
            Threading.Thread.Sleep(10)
            Application.DoEvents()
        Loop While client.CommunicationState = HSCF.Communication.Scs.Communication.CommunicationStates.Connected Or clientCallback.CommunicationState = HSCF.Communication.Scs.Communication.CommunicationStates.Connected
        Console.WriteLine("Now Disconnected from HS3")
        plugin = Nothing
        client.Dispose()
        clientCallback.Dispose()
        client = Nothing
        clientCallback = Nothing
        wait(3)
        Console.WriteLine("Now terminating tenscripting3.exe")
        TerminatingForm.Close()
        Me.Close()
    End Sub

    Private Sub GetScripts()
        Dim anAssembly As Assembly
        Dim modules() As System.Reflection.Module, aModule As [Module]
        Dim methodinfos() As MethodInfo
        Dim types() As Type
        Dim sd As ScriptData
        Dim DI As IO.DirectoryInfo, FIs() As IO.FileInfo, FI As IO.FileInfo
        Dim ed, p As String, i As Integer
        Dim Excludes() As String = {"FRMCONNECTION.DESIGNER.VB",
            "FRMCONNECTION.VB",
            "FRMDEBUGSETTINGS.DESIGNER.VB",
            "FRMDEBUGSETTINGS.VB",
            "FRMSCRIPTEXPORT.DESIGNER.VB",
            "FRMSCRIPTEXPORT.VB",
            "TENSCRIPTING.DESIGNER.VB",
            "TENSCRIPTING.VB",
            "FRMWEBPORT.VB",
            "FRMWEBPORT.DESIGNER.VB",
            "FRMSCRIPTIMPORT.VB",
            "FRMSCRIPTIMPORT.DESIGNER.VB",
            "HSPI.VB",
            "UTIL.VB",
            "FRMSCRIPTFOLDER.VB",
            "FRMSCRIPTFOLDER.DESIGNER.VB",
            "FRMTERMINATING.VB", "FRMTERMINATING.DESIGNER.VB",
            "FRMTRIGGERS.VB", "FRMTRIGGERS.DESIGNER.VB"}
        '' Get all of the Files, Classes, Methods from the VS Project Files
        ed = My.Application.Info.DirectoryPath          'executable directory
        i = ed.IndexOf("bin")                           'offset to project sub directory
        p = ed.Substring(0, i)                          'path to project sub directory
        DI = New IO.DirectoryInfo(p)
        FIs = DI.GetFiles
        Exports.Clear()                                 'clear target list of scripts
        For Each FI In FIs
            If FI.Extension.ToUpper = ".VB" Then
                i = Array.IndexOf(Excludes, FI.Name.ToUpper)
                If Array.IndexOf(Excludes, FI.Name.ToUpper) = -1 Then
                    Me.cboFiles.Items.Add(FI.Name)
                    'MyLog("Found Source File " & FI.Name.ToUpper)
                    Console.WriteLine("Getting Classes for: " & FI.FullName)
                    GetClasses(FI.FullName)
                End If
            End If
        Next
        If Me.cboFiles.Items.Count > 0 Then
            '' Determine File Selection
            Me.cboFiles.SelectedIndex = 0
            For i = 0 To Me.cboFiles.Items.Count - 1
                If Me.cboFiles.Items(i).ToString = My.Settings.LastFile Then
                    Me.cboFiles.SelectedIndex = i
                    Exit For
                End If
            Next
        End If
        Me.cboFiles.Refresh()
        '' Get all of the Methods Loaded into Memory
        anAssembly = Assembly.GetExecutingAssembly()
        modules = anAssembly.GetLoadedModules()
        aModule = modules(0)
        types = aModule.GetTypes()
        For Each t As Type In types
            methodinfos = t.GetMethods
            For Each m As MethodInfo In methodinfos
                If Scripts.ContainsKey(t.Name & "." & m.Name) Then
                    sd = Scripts(t.Name & "." & m.Name)
                    sd.oType = t
                    'MyLog("Loaded Method " & sd.ClassName.ToUpper & "." & sd.MethodName.ToUpper)
                End If
            Next
        Next
    End Sub

    Friend Sub GetProjectFiles()
        Dim sr As IO.StreamReader
        Dim fn, s1, s2, s3 As String, i1, i2 As Integer
        '' Open the tenscripting Project File
        s1 = My.Application.Info.DirectoryPath.Substring(0, My.Application.Info.DirectoryPath.IndexOf("bin"))                          'path to project sub directory
        fn = s1 & "tenscripting3.vbproj"
        sr = IO.File.OpenText(fn)
        '' Find all Compile Entries
        Do While Not sr.EndOfStream
            s1 = sr.ReadLine
            If s1.Trim.ToUpper.Contains("<COMPILE INCLUDE=") Then
                '' Found Entry, strip name and add to list
                i1 = s1.IndexOf("""")
                s2 = s1.Substring(i1 + 1, s1.Length - i1 - 1)
                i2 = s2.IndexOf("""")
                s3 = s2.Substring(0, i2)
                ProjectFiles.Add(s3.ToUpper, s3.ToUpper)
            End If
        Loop
    End Sub

    Friend Sub GetClasses(ByVal fn As String)
        Dim sr As IO.StreamReader, ClassStatements As New Specialized.StringCollection
        Dim ClassName As String = ""
        Dim l As String, Imps As New Specialized.StringCollection
        Dim LevelOfClassStatements As Integer
        Dim theFN As String
        '' Open Script File
        sr = IO.File.OpenText(fn)                        'open the Scripts.vb file
        '' Loop through Source file
        LevelOfClassStatements = 0
        Do While Not sr.EndOfStream
            '' Look for start of Class definition
            l = sr.ReadLine()
            If l.Trim.ToUpper.Length > 6 Then
                If l.Trim.ToUpper.Substring(0, 7) = "IMPORTS" Then
                    '' Save IMPORTS statement to add to each class/script in the file
                    Imps.Add(l)
                End If
            End If
            If IsClassStatement(l) Then
                '' Found a Class definition
                LevelOfClassStatements += 1
                If LevelOfClassStatements = 1 Then
                    ClassStatements = New Specialized.StringCollection
                    '' Save the Class Name
                    ClassName = l.Substring(l.ToUpper.IndexOf("CLASS") + 6).Trim
                End If
                '' Look for End of Class definition
                Do
                    l = sr.ReadLine
                    If IsClassStatement(l) Then
                        LevelOfClassStatements += 1
                    End If
                    If IsEndClassStatement(l) Then
                        LevelOfClassStatements -= 1
                        If LevelOfClassStatements < 1 Then
                            Exit Do
                        End If
                    End If
                    ClassStatements.Add(l)              'add a line of the definition
                Loop
                '' Add any IMPORT statements found in the file to each Class (Script)
                For Each s As String In Imps
                    '' Insert the saved IMPORTS statements
                    ClassStatements.Insert(0, s)
                Next
                '' Have accumulated the Class definition, add it to collection
                Try
                    If Exports.ContainsKey(ClassName) Then
                        '' Class already saved, this is duplicate
                        theFN = "????"
                        For Each ScrData As ScriptData In Scripts.Values
                            If ScrData.ClassName = ClassName Then
                                theFN = ScrData.Filename
                                Exit For
                            End If
                        Next
                        MsgBox("Scanning all of your Script Files (.vb)" & vbCrLf & vbCrLf &
                               "  Currently scanning file: " & fn & vbCrLf & vbCrLf & "  Found duplicate Script (Class): " & ClassName &
                               vbCrLf & vbCrLf &
                                "  This definition of " & ClassName & " will be ignored" &
                               vbCrLf & vbCrLf & "The first defintion of " & ClassName & " was found in File: " & theFN, , "Found duplicate Script (Class)")
                    Else
                        '' New Class, add to list
                        Exports.Add(ClassName, ClassStatements)
                    End If
                Catch ex As Exception
                    MyLog("Exception Processing Class: " & ClassName)
                    MyLog("Suspect you have defined the Class more than once")
                    MyLog("This could be duplicates in multiple files in the project directory, even if they are not defined in the project itself.")
                    MyLog("Script Processing Truncated for " & ClassName)
                    MyLog("Exception: " & ex.Message)
                End Try
                'MyLog("--Found Class " & ClassName.ToUpper)
                Console.WriteLine("Getting Methods for: " & ClassName)
                GetMethods(fn, ClassName)
            End If
        Loop
        sr.Close()
        sr = Nothing
    End Sub

    Friend Function IsClassStatement(l As String) As Boolean
        Dim s As String
        ''
        '' Determine if line from file is a CLASS statement
        ''
        s = l.ToUpper.Trim
        If s.Length < 6 Then Return False
        If s.Substring(0, 1) = "'" Then Return False
        If Not s.Contains("CLASS ") Then Return False
        If s.Substring(0, 6) = "CLASS " Then Return True
        If s.Substring(0, 13) = "PUBLIC CLASS " Then Return True
        Return False
    End Function

    Friend Function IsEndClassStatement(l As String) As Boolean
        Dim s As String
        ''
        '' Determine if line from file is a END CLASS statement
        ''
        s = l.ToUpper.Trim
        If s.Length < 9 Then Return False
        If s.Substring(0, 1) = "'" Then Return False
        If Not s.Contains("END ") Or Not s.Contains(" CLASS") Then Return False
        If s.Substring(0, 9) = "END CLASS" Then Return True
        Return False
    End Function

    Friend Sub GetMethods(ByVal fn As String, ByVal cn As String)
        Dim ClassStatements As Specialized.StringCollection
        Dim i As Integer, MethodName As String
        Dim sd As ScriptData
        Dim ClassLevel As Integer = 0
        ClassStatements = Exports(cn)                               ' fetch all of the statements in the class
        i = 0
        Do
            '' Loop through class statements
            If i > ClassStatements.Count - 1 Then Exit Do
            If IsClassStatement(ClassStatements(i)) Then ClassLevel += 1
            If IsEndClassStatement(ClassStatements(i)) Then ClassLevel -= 1
            If IsSubStatement(ClassStatements(i)) And ClassLevel < 1 Then
                '' Found a Method definition
                MethodName = ClassStatements(i).Substring(ClassStatements(i).ToUpper.IndexOf("SUB") + 4).Trim
                MethodName = MethodName.Substring(0, MethodName.IndexOf("(")).Trim
                'MyLog("----Found Sub " & MethodName.ToUpper & " in " & cn)
                sd = New ScriptData(fn, cn, MethodName, Me.GetType)
                Try
                    Scripts.Add(sd.ClassName & "." & sd.MethodName, sd)
                Catch ex As Exception
                    MyLog("Exception Processing Method: " & sd.ClassName & "." & sd.MethodName)
                    MyLog("Suspect you have defined the Class and/or Method more than once")
                    MyLog("This could be duplicates in multiple files in the project directory, even if they are not defined in the project itself.")
                    MyLog("Script Processing Truncated for " & sd.ClassName & "." & sd.MethodName)
                    MyLog("   Exception: " & ex.Message)
                End Try
                '' Look for End of Class definition
                i = i + 1
                Do
                    If IsEndSubStatement(ClassStatements(i)) Then Exit Do
                    i = i + 1
                Loop
            End If
            i = i + 1
        Loop
    End Sub

    Friend Function IsSubStatement(l As String) As Boolean
        Dim s As String
        ''
        '' Determine if line from file is a PUBLIC SUB statement
        ''
        s = l.ToUpper.Trim
        If s.Length < 11 Then Return False
        If s.Substring(0, 1) = "'" Then Return False
        If Not s.Contains("PUBLIC SUB ") Then Return False
        If s.Substring(0, 11) = "PUBLIC SUB " Then Return True
        Return False
    End Function

    Friend Function IsEndSubStatement(l As String) As Boolean
        Dim s As String
        ''
        '' Determine if line from file is a END SUB statement
        ''
        s = l.ToUpper.Trim
        If s.Length < 7 Then Return False
        If s.Substring(0, 1) = "'" Then Return False
        If Not s.Contains("END ") Or Not s.Contains(" SUB") Then Return False
        If s.Substring(0, 7) = "END SUB" Then Return True
        Return False
    End Function

    Friend Sub DeleteDebugLog()
        Dim dir As String
        dir = My.Settings.DebugLogPath
        If dir.Substring(dir.Length - 1, 1) <> "\" Then dir = dir & "\"
        If IO.Directory.Exists(dir) Then
            '' Found Directory
            Try
                If IO.File.Exists(dir & "Debug_Composite.Log") Then
                    IO.File.Delete(dir & "Debug_Composite.Log")
                    MyLog("Deleted: " & dir & "Debug_Composite.Log")
                End If
            Catch ex As Exception
                MyLog("Exception Trying to Delete Debug Log: " & dir & "Debug_Composite.Log")
                MyLog("... " & ex.Message)
            End Try
        Else
            '' Directory Not Found
            MyLog("Debug Log Directory Not Found: " & dir)
        End If
    End Sub

    Public Sub UpdateDevices(ByVal p As String)
        Dim dc, ds As String
        Dim i As Integer, a As String, dt As Date
        Dim PossibleStatus As String() = {"", "", "On", "Off", "Dim", "Dim", "", "", "", "", "", "", "", "", "", "", "", "Unknown"}
        Dim sd As ScriptData
        Dim parms() As String
        Dim aDev As Scheduler.Classes.DeviceClass
        ''
        '' UpdateDevices is called for each Event received from HS   (HSPI.HsEvent)
        ''
        If HSPI.bShutDown Then Exit Sub
        Try
            '' Get individual parms from string
            parms = p.Split(Chr(2))
            '' Check if this matches a Trigger
            dt = Now
            ds = Format(dt, "mm:ss")
            dc = ""
            i = CType(parms(0), Integer)
            Select Case i
                Case &H2
                    '' Log Record
                    a = parms(2).ToString
                    lstHomeseerLog.Items.Add(Format(ln Mod 100, "00 ") & ds & " | " & a & " | " & parms(3))
                    ln = ln + 1
                    If Not Me.FreezeLog Then
                        lstHomeseerLog.SelectedIndex = lstHomeseerLog.Items.Count - 1
                        lstHomeseerLog.Refresh()
                        lstHomeseerLog.SelectedItems.Clear()
                    End If
                Case &H40
                    '' String Change
                    dc = parms(3)       'Dev Ref Number
                    aDev = CType(hs.GetDeviceByRef(CInt(dc)), Classes.DeviceClass)
                    Me.lstChanges.Items.Add(Format(ln Mod 100, "00 ") & ds & " (" & dc & ") New DeviceString=" & parms(2).ToString & "   [" & aDev.Location(hs) & " " & aDev.Location2(hs) & " " & aDev.Name(hs) & "]")
                    ln = ln + 1
                    If Not Me.FreezeEvents Then
                        Me.lstChanges.SelectedIndex = Me.lstChanges.Items.Count - 1
                        Me.lstChanges.Refresh()
                        lstChanges.SelectedItems.Clear()
                    End If
                Case &H400
                    '' Value Change
                    dc = parms(4)      ' Device Ref Number
                    aDev = CType(hs.GetDeviceByRef(CInt(dc)), Classes.DeviceClass)
                    Me.lstChanges.Items.Add(Format(ln Mod 100, "00 ") & ds & " (" & dc & ") Old Value=" & parms(3).ToString & "  New Value=" & parms(2).ToString & "   [" & aDev.Location(hs) & " " & aDev.Location2(hs) & " " & aDev.Name(hs) & "]")
                    ln = ln + 1
                    If Not Me.FreezeEvents Then
                        Me.lstChanges.SelectedIndex = Me.lstChanges.Items.Count - 1
                        Me.lstChanges.Refresh()
                        lstChanges.SelectedItems.Clear()
                    End If
                    '' Check if active filter should trigger a script
                    If My.Settings.TriggersEnabled Then
                        dc = parms(4).ToUpper.Trim          ' string of Device Ref
                        '' Value or Status Change, so look for a matching trigger
                        For Each t As TriggerData In Triggers
                            If t.Device.ToUpper.Trim = dc.ToUpper.Trim Then
                                '' Found a trigger for this device
                                If Scripts.ContainsKey(t.Script & "." & t.Method) Then
                                    sd = Scripts(t.Script & "." & t.Method)
                                    sd.Parms = t.Parms
                                    SyncLock qTriggers
                                        qTriggers.Enqueue(sd)
                                    End SyncLock
                                    MyLog("Device Triggered for:" & dc & " " & t.Script & "." & t.Method)
                                Else
                                    MyLog("SCRIPT TRIGGER METHOD MISSING: " & t.Script & "." & t.Method)
                                End If
                            End If
                        Next
                    End If
                Case Else
                    '' HsEvent we are not interested in
            End Select
        Catch ex As Exception
            Console.WriteLine("Exception in UpdateDevices: " & ex.Message)
        End Try
    End Sub

    Private Sub SetRunButtonText()
        Dim s, p As String
        '' Get Script name
        If Me.cboMethods.Items.Count > 0 Then
            s = Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString & "." & Me.cboMethods.Items(Me.cboMethods.SelectedIndex).ToString
        Else
            s = ""
        End If
        '' Get parms
        p = """" & Me.txtParms.Text & """"
        Me.btnRunSubMain.Text = s & "(" & p & ")"
    End Sub

    Private Sub btnRunSubMain_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRunSubMain.Click
        Dim s, p As String
        Dim ss(0) As Object
        Dim sss() As String
        '' Check that the File that is to be run has been included in the Project File
        s = Me.cboFiles.Items(Me.cboFiles.SelectedIndex).ToString
        If Not ProjectFiles.Keys.Contains(s.ToUpper) Then
            '' VB file was in the project folder, but not in the Project File.  Cannot run it
            MsgBox("You cannot Run " & s & vbCrLf & vbCrLf & "It was not included in the Project and was not compiled" & vbCrLf & vbCrLf & "Add it to the Project using VS Menu item Project/Add Existing Item...",, "tenScripting")
            Exit Sub
        End If
        Me.tmrTriggers.Stop()
        '' Save the Selection Boxes
        My.Settings.LastFile = Me.cboFiles.Items(Me.cboFiles.SelectedIndex).ToString
        My.Settings.LastClass = Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString
        My.Settings.LastMethod = Me.cboMethods.Items(Me.cboMethods.SelectedIndex).ToString
        My.Settings.Save()
        '' Save the Parms for this Script
        s = Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString & "." & Me.cboMethods.Items(Me.cboMethods.SelectedIndex).ToString
        '''' Remove any existing entry
        For i As Integer = 0 To My.Settings.Parms.Count - 1
            p = My.Settings.Parms(i)
            If s.Length + 1 <= p.Length Then
                If p.Substring(0, s.Length + 1).ToUpper = s.ToUpper & "=" Then
                    My.Settings.Parms.RemoveAt(i)
                    Exit For
                End If
            End If
        Next i
        '''' Now save the current parm
        My.Settings.Parms.Add(s.ToUpper & "=" & Me.txtParms.Text.ToString)
        My.Settings.Save()
        '' Get the Parms
        s = Me.txtParms.Text.ToString
        If My.Settings.ProcessAsHsParms Then
            '' Process as HS parms: Only single parm, truncates at ","
            If s.IndexOf(",") >= 0 Then
                s = s.Substring(0, s.IndexOf(","))
            End If
            ss(0) = s
        Else
            '' Process as normal parms (HsTouch for Example): Parms separated by ","
            sss = s.Split(ToChar(","))
            ss(0) = sss
        End If
        '' Run the Script
        RunScript(Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString, Me.cboMethods.Items(Me.cboMethods.SelectedIndex).ToString, ss)
        Me.tmrTriggers.Start()
    End Sub

    Friend Sub RunScript(ByVal pClass As String, ByVal pMethod As String, ByVal pParms() As Object)
        Dim anObj As Object, t As Type
        Dim s As String
        Dim sd As ScriptData
        If pMethod.ToUpper = "MAIN" And pMethod <> "Main" Then
            MyLog("Warning:  Method name= " & pMethod & "   HS will only find 'Main' as a default method")
            MsgBox("Warning:  Method name= " & pMethod & "   HS will only find 'Main' as a default method", , "tenScripting")
        End If
        '' Hide the Debug Button
        Me.btnDebugLogs.Visible = False
        Me.lblScriptRunning.Visible = True
        Me.lblScriptRunning.Refresh()
        '' Create instance of class containing script to run
        s = pClass & "." & pMethod
        sd = Scripts(s)
        t = sd.oType
        anObj = Activator.CreateInstance(t)
        '' Log we are now running a script
        MyLog("Running " & sd.ClassName & "." & sd.MethodName)
        hs.WriteLog("tenScripting", "****************************** Debug Started for " & sd.ClassName & "." & sd.MethodName)
        '' Run the Script
        Try
            t.InvokeMember(sd.MethodName, BindingFlags.InvokeMethod Or BindingFlags.Instance Or
                BindingFlags.Public Or BindingFlags.IgnoreCase,
                Nothing, anObj, pParms, Nothing, Nothing, Nothing)
        Catch ex As Exception
            MyLog(">>> Exception")
            MyLog(">>> " & ex.Message)
            If Not IsNothing(ex.InnerException) Then
                MyLog(">>>>> " & ex.InnerException.Message)
                MyLog(">>>>> " & ex.InnerException.StackTrace)
            End If
            Beep()
            MsgBox("Execution Error in " & sd.ClassName & "." & sd.MethodName & ", see tenScripting Log")
        Finally
            hs.WriteLog("tenScripting", "****************************** Debug Ended for " &
                sd.ClassName & "." & sd.MethodName)
            Me.lblScriptRunning.Visible = False
            Me.btnDebugLogs.Visible = My.Settings.DebugLoggingEnabled
        End Try
        MyLog(sd.ClassName & "." & sd.MethodName & " Finished")
    End Sub

    Private Sub txtParms_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtParms.TextChanged
        SetRunButtonText()
    End Sub

    Private Sub ExittenScripting()
        '' Turn OFF HS Debug Logging
        Try
            MyLog("tenScripting Closing")
            hs.WriteLog("tenScripting", "tenScripting Closing")
            hs.DebugMode = 0
            HSPI.bShutDown = True
        Catch ex As Exception
        End Try
        Console.WriteLine("ExittenScripting set bShutdown=True")
    End Sub

    Private Sub ExportScriptsToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportScriptsToolStripMenuItem.Click
        Dim ExportForm As frmScriptExport
        '' Display the Script Export Form
        ExportForm = New frmScriptExport
        For Each s As String In Me.cboFiles.Items
            ExportForm.cboFiles.Items.Add(s)
        Next
        ExportForm.ShowDialog()
        ExportForm = Nothing
    End Sub

    Private Sub DonationToCysticFibrosisFoundationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim p As String
        p = "http://www.tenholder.net/CharityWare/"
        Process.Start(p)
    End Sub

    Function Version() As String
        With _
       System.Diagnostics.FileVersionInfo.GetVersionInfo(System.Reflection.Assembly.GetExecutingAssembly.Location)
            Return .FileMajorPart & "." & .FileMinorPart
        End With
    End Function

    Private Sub mnuHsLogSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHsLogSettings.Click
        Dim f As frmDebugSettings
        f = New frmDebugSettings
        f.chkEnableDebugLog.Checked = My.Settings.DebugLoggingEnabled
        f.txtDebugLogPath.Visible = My.Settings.DebugLoggingEnabled
        f.lblDebugLogPath.Visible = My.Settings.DebugLoggingEnabled
        f.txtDebugLogPath.Text = My.Settings.DebugLogPath
        f.ShowDialog()
        Me.btnDebugLogs.Visible = My.Settings.DebugLoggingEnabled
        If My.Settings.DebugLoggingEnabled Then
            hs.DebugMode = 15
        Else
            hs.DebugMode = 0
        End If
        f = Nothing
    End Sub

    Private Sub CFFToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CFFToolStripMenuItem.Click
        Dim p As String
        p = "http://www.tenholder.net/tenWare2/CharityWare.aspx"
        Process.Start(p)
    End Sub

    Private Sub ConnectionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectionToolStripMenuItem.Click
        Dim ConnectForm As frmConnection
        ConnectForm = New frmConnection
        ConnectForm.ShowDialog()
        ConnectForm = Nothing
    End Sub

    Private Sub cboScripts_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboMethods.SelectedIndexChanged
        Dim s As String
        '' Get selected Script
        s = Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString & "." & Me.cboMethods.Items(Me.cboMethods.SelectedIndex).ToString
        Me.txtParms.Text = ""
        For Each p As String In My.Settings.Parms
            '' Check if Parms are stored for this Script
            If s.Length + 1 <= p.Length Then
                If p.Substring(0, s.Length + 1).ToUpper = s.ToUpper & "=" Then
                    '' Place Parms into control
                    Me.txtParms.Text = p.Substring(s.Length + 1)
                    Exit For
                End If
            End If
        Next
        SetRunButtonText()
    End Sub

    Private Sub btnFreeze_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFreeze.Click
        If Me.btnFreeze.Text = "Freeze" Then
            Me.btnFreeze.Text = "Scroll"
            Me.FreezeEvents = True
        Else
            Me.btnFreeze.Text = "Freeze"
            Me.FreezeEvents = False
        End If
    End Sub

    Private Sub cboFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboFiles.SelectedIndexChanged
        Dim cFile, dFile As String, Found As Boolean
        cFile = Me.cboFiles.Items(Me.cboFiles.SelectedIndex).ToString.ToUpper
        Me.cboClasses.Items.Clear()
        For Each sd As ScriptData In Scripts.Values
            dFile = IO.Path.GetFileName(sd.Filename).ToUpper
            If dFile = cFile Then
                '' Only add if not there already (multiple methods for same class)
                Found = False
                For Each s As String In cboClasses.Items
                    If s = sd.ClassName Then
                        Found = True
                        Exit For
                    End If
                Next
                If Not Found Then Me.cboClasses.Items.Add(sd.ClassName)
            End If
        Next
        If Me.cboClasses.Items.Count > 0 Then
            '' Determine Class Selection
            Me.cboClasses.SelectedIndex = 0
            For i As Integer = 0 To Me.cboClasses.Items.Count - 1
                If Me.cboClasses.Items(i).ToString = My.Settings.LastClass Then
                    Me.cboClasses.SelectedIndex = i
                    Exit For
                End If
            Next
        End If
        Me.cboClasses.Refresh()
    End Sub

    Private Sub cboClasses_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboClasses.SelectedIndexChanged
        Dim cClass, dClass As String
        cClass = Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString.ToUpper
        Me.cboMethods.Items.Clear()
        For Each sd As ScriptData In Scripts.Values
            dClass = IO.Path.GetFileName(sd.ClassName).ToUpper
            If dClass = cClass Then
                Me.cboMethods.Items.Add(sd.MethodName)
            End If
        Next
        If Me.cboMethods.Items.Count > 0 Then
            '' Determine Method Selection
            Me.cboMethods.SelectedIndex = 0
            For i As Integer = 0 To Me.cboMethods.Items.Count - 1
                If Me.cboMethods.Items(i).ToString = My.Settings.LastMethod Then
                    Me.cboMethods.SelectedIndex = i
                    Exit For
                End If
            Next
        End If
        Me.cboMethods.Refresh()
    End Sub

    Private Sub TenScriptingWebSiteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TenScriptingWebSiteToolStripMenuItem.Click
        ''
        '' Display tenScripting Web Site in Browser
        ''
        Dim p As String

        p = "http://www.tenholder.net/tenWare2/tenScripting"
        Process.Start(p)
    End Sub

    Private Sub HomeSeerHelpFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HomeSeerHelpFileToolStripMenuItem.Click
        ''
        '' Display HomeSeer Help File in Browser
        ''
        Dim p As String
        p = "http://help.homeseer.com/help/HS3/static/"
        Process.Start(p)
    End Sub

    Private Sub HomeSeerSDKToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HomeSeerSDKToolStripMenuItem.Click
        ''
        '' Display HomeSeer SDK in Browser
        ''
        Dim p As String
        p = "https://help.homeseer.com/help/HS3SDK/static/default.htm"
        Process.Start(p)
    End Sub

    Private Sub btnFreezeLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFreezeLog.Click
        If Me.btnFreezeLog.Text = "Freeze" Then
            Me.btnFreezeLog.Text = "Scroll"
            Me.FreezeLog = True
        Else
            Me.btnFreezeLog.Text = "Freeze"
            Me.FreezeLog = False
        End If
    End Sub

    Private Sub btnScriptingLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScriptingLog.Click
        If Me.btnScriptingLog.Text = "Freeze" Then
            Me.btnScriptingLog.Text = "Scroll"
            Me.ScriptingLog = True
        Else
            Me.btnScriptingLog.Text = "Freeze"
            Me.ScriptingLog = False
        End If
    End Sub

    Private Sub picHS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picHS.Click
        ''
        '' Display HomeSeer Status Page
        ''
        Dim p As String
        p = "http://" & My.Settings.HsComputer & ":" & hs.GetINISetting("Settings", "gWebSvrPort", "80")
        Process.Start(p)
    End Sub

    Private Sub btnDebugLogs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDebugLogs.Click
        ''
        '' Display HomeSeer Debug Log
        ''
        Dim dir As String
        dir = My.Settings.DebugLogPath
        If dir.Substring(dir.Length - 1, 1) <> "\" Then dir = dir & "\"
        If IO.File.Exists(dir & "Debug_Composite.Log") Then
            '' File Exists
            If Me.DebugLogProccess Is Nothing Then
                '' Notepad not already open
                Me.DebugLogProccess = Process.Start("Notepad.exe", dir & "Debug_Composite.Log")
            Else
                If Not Me.DebugLogProccess.HasExited Then
                    '' Notepad still running
                    Me.DebugLogProccess.Kill()
                    Me.DebugLogProccess = Nothing
                    Me.DebugLogProccess = Process.Start("Notepad.exe", dir & "Debug_Composite.Log")
                Else
                    Me.DebugLogProccess = Nothing
                    Me.DebugLogProccess = Process.Start("Notepad.exe", dir & "Debug_Composite.Log")
                End If
            End If
        Else
            '' File does not exist
            MyLog("Could not find Debug Log: " & dir & "Debug_Composite.Log")
        End If
    End Sub

    Private Sub lstHomeseerLog_DrawItem(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles lstHomeseerLog.DrawItem
        Dim textBrush As Brush
        Dim drawFont As Font
        If HSPI.bShutDown Then Exit Sub
        Try
            If lstHomeseerLog.Items.Count < 1 Or e.Index < 0 Then Exit Sub
            drawFont = e.Font
            e.DrawBackground()
            If Me.lstHomeseerLog.Items(e.Index).ToString.Contains("tenScripting") Then
                textBrush = Brushes.Red
                drawFont = New Font(drawFont.FontFamily, drawFont.Size, FontStyle.Regular)
            Else
                textBrush = Brushes.Black
            End If
            e.Graphics.DrawString(lstHomeseerLog.Items.Item(e.Index).ToString(), drawFont, textBrush, e.Bounds.X, e.Bounds.Y)
        Catch ex As Exception
            MyLog("Exception in lstHomeseerLog_DrawItem")
            MyLog("  Ex: " & ex.Message)
            MyLog("  e.Index: " & e.Index)
        End Try
    End Sub

    Private Sub chkTriggers_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkTriggers.CheckedChanged
        My.Settings.TriggersEnabled = Me.chkTriggers.Checked
        My.Settings.Save()
        Me.btnTriggers.Visible = Not My.Settings.TriggersEnabled
        If My.Settings.TriggersEnabled Then
            MyLog("Monitoring Device Triggers")
            Me.tmrTriggers.Start()
        Else
            MyLog("Device Trigger Monitoring Stopped")
        End If
    End Sub

    Private Sub btnTriggers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTriggers.Click
        '' Display Triggers Dialog
        Dim f As frmTriggers
        f = New frmTriggers
        '' Populate the File Drop Down List
        For Each s As String In Me.cboFiles.Items
            f.cboFile.Items.Add(s)
        Next
        If f.cboFile.Items.Count > 0 Then f.cboFile.SelectedIndex = 0
        f.ShowDialog()
        f = Nothing
        SaveTriggers()
    End Sub

    Friend Sub GetTriggers()
        Dim ss() As String
        Dim t As TriggerData
        Dim sc As New System.Collections.Specialized.StringCollection
        sc = My.Settings.Triggers
        If Not sc Is Nothing Then
            If sc.Count > 0 Then
                For Each s As String In sc
                    ss = s.Split(ToChar(sep))
                    t = New TriggerData(ss(0), ss(1), ss(2), ss(3), ss(4), ss(5))
                    Triggers.Add(t)
                Next
            End If
        End If
    End Sub

    Friend Sub SaveTriggers()
        Dim sc As New System.Collections.Specialized.StringCollection
        Dim a As String
        For Each t As TriggerData In Triggers
            a = t.Device & sep & t.Condition & sep & t.File & sep & t.Script & sep & t.Method & sep & t.Parms
            sc.Add(a)
        Next
        My.Settings.Triggers = sc
        My.Settings.Save()
    End Sub

    Private Sub tmrTriggers_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmrTriggers.Tick
        Dim sd As ScriptData
        Dim ss(0) As String
        tmrTriggers.Stop()
        '' Check if their are any Triggered Scripts to Run
        If qTriggers.Count > 0 Then
            '' There are queued scripts
            SyncLock qTriggers
                sd = qTriggers.Dequeue              ' get the script info from Q
            End SyncLock
            ss(0) = sd.Parms
            RunScript(sd.ClassName, sd.MethodName, ss)
        End If
        tmrTriggers.Start()
    End Sub

    Private Sub chkProcessAsHsParms_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkProcessAsHsParms.CheckedChanged
        If StartupComplete Then
            My.Settings.ProcessAsHsParms = chkProcessAsHsParms.Checked
            My.Settings.Save()
        End If
    End Sub

    Friend Sub MyLog(ByVal t As String)
        Me.lstLog.Items.Add(Format(ln Mod 100, "00 ") & t)
        ln = ln + 1
        If Not Me.ScriptingLog Then
            Me.lstLog.SelectedIndex = Me.lstLog.Items.Count - 1
            Me.lstLog.Refresh()
            lstLog.SelectedItems.Clear()
            Console.WriteLine(Format(ln Mod 100, "00 ") & t)
        End If
    End Sub

    Private Sub ImportScriptsToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles ImportScriptsToolStripMenuItem.Click
        Dim ImportForm As frmScriptImport
        '' Display the Script Inport Form
        ImportForm = New frmScriptImport
        For Each s As String In Me.cboFiles.Items
            ImportForm.cboFiles.Items.Add(s)
        Next
        ImportForm.ShowDialog()
        ImportForm = Nothing
    End Sub

    Private Sub btnCopyEvents_Click(sender As System.Object, e As System.EventArgs) Handles btnCopyEvents.Click
        Dim s As String = " "
        For Each ss As String In lstChanges.SelectedItems
            s = s & ss & vbCrLf
        Next
        Clipboard.SetText(s)
    End Sub

    Private Sub btnCopytenLog_Click(sender As System.Object, e As System.EventArgs) Handles btnCopytenLog.Click
        Dim s As String = " "
        For Each ss As String In lstLog.SelectedItems
            s = s & ss & vbCrLf
        Next
        Clipboard.SetText(s)
    End Sub

    Private Sub btnCopyHsLog_Click(sender As System.Object, e As System.EventArgs) Handles btnCopyHsLog.Click
        Dim s As String = " "
        For Each ss As String In lstHomeseerLog.SelectedItems
            s = s & ss & vbCrLf
        Next
        Clipboard.SetText(s)
    End Sub

    Private Sub btnExit_Click(sender As System.Object, e As System.EventArgs) Handles btnExit.Click
        Me.ExittenScripting()
    End Sub

    Private Sub btnGetLog_Click(sender As Object, e As EventArgs) Handles btnGetLog.Click
        Dim ss() As LogEntry
        Dim d1, d2 As Date
        lstHomeseerLog.Items.Clear()
        d1 = Now
        d2 = DateAdd(DateInterval.Hour, -1, Now)
        ss = hs.GetLog_Date(d2, d1)
        For Each le As LogEntry In ss
            lstHomeseerLog.Items.Add("00 " & Format(le.LogTime, "mm:ss") & " | " & le.LogText)
        Next
        lstHomeseerLog.SelectedIndex = lstHomeseerLog.Items.Count - 1
        lstHomeseerLog.Refresh()
        lstHomeseerLog.SelectedItems.Clear()
    End Sub

    Private Sub tenScriptAidMenuItem_Click(sender As Object, e As EventArgs) Handles tenScriptAidMenuItem.Click
        '' Run tenScriptAid Program
        Dim SavedLocation As String = My.Computer.FileSystem.SpecialDirectories.MyDocuments & "\tenScriptAidLocation.txt"
        Dim p As String
        '' Get Location of tenScriptAid.exe
        If Not System.IO.File.Exists(SavedLocation) Then
            '' File with saved location not found
            MsgBox("Could not find the saved location of TenScriptAid" & Environment.NewLine & Environment.NewLine & "Make sure that you have run tenScriptAid 1.25 or higher at least once",, "tenScripting")
            Exit Sub
        End If
        p = System.IO.File.ReadAllText(SavedLocation, System.Text.Encoding.ASCII)
        If Not System.IO.File.Exists(p) Then
            MsgBox("Invalid saved location of TenScriptAid" & Environment.NewLine & Environment.NewLine & "Make sure that you have run tenScriptAid 1.25 or higher at least once",, "tenScripting")
            Exit Sub
        End If
        Process.Start(p)        ''
    End Sub

    Private Sub btnRunTenScriptAid_Click(sender As Object, e As EventArgs) Handles btnRunTenScriptAid.Click
        '' Run tenScriptAid Program
        Dim p As String
        '' Get Location of tenScriptAid.exe
        If Not System.IO.File.Exists(SavedLocation) Then
            '' File with saved location not found
            MsgBox("Could not find the saved location of TenScriptAid" & Environment.NewLine & Environment.NewLine & "Make sure that you have run tenScriptAid 1.25 or higher at least once",, "tenScripting")
            Exit Sub
        End If
        p = System.IO.File.ReadAllText(SavedLocation, System.Text.Encoding.ASCII)
        If Not System.IO.File.Exists(p) Then
            MsgBox("Invalid saved location of TenScriptAid" & Environment.NewLine & Environment.NewLine & "Make sure that you have run tenScriptAid 1.25 or higher at least once",, "tenScripting")
            Exit Sub
        End If
        Process.Start(p)        ''
    End Sub

    Private Sub chkSkipEvents_CheckedChanged(sender As Object, e As EventArgs) Handles chkSkipEvents.CheckedChanged
        My.Settings.SkipEvents = chkSkipEvents.Checked
        My.Settings.Save()
        If StartupComplete Then
            MsgBox("The change to Skip Events will take effect when tenScripting is restarted",, "tenScripting")
        End If
    End Sub
End Class


Class ScriptData
    Dim _FileName As String
    Dim _ClassName As String
    Dim _MethodName As String
    Dim _oType As Type
    Dim _Parms As String

    Friend Sub New(ByVal FileName As String, ByVal ClassName As String, ByVal MethodName As String, ByVal oType As Type)
        _FileName = FileName
        _ClassName = ClassName
        _MethodName = MethodName
        _oType = oType
    End Sub

    Friend Property Parms() As String
        Get
            Return _Parms
        End Get
        Set(ByVal value As String)
            _Parms = value
        End Set
    End Property

    Friend ReadOnly Property Filename() As String
        Get
            Return _FileName
        End Get
    End Property

    Friend ReadOnly Property ClassName() As String
        Get
            Return _ClassName
        End Get
    End Property

    Friend ReadOnly Property MethodName() As String
        Get
            Return _MethodName
        End Get
    End Property

    Friend Property oType() As Type
        Get
            Return _oType
        End Get
        Set(ByVal value As Type)
            _oType = value
        End Set
    End Property
End Class

Class TriggerData
    Dim _Device As String
    Dim _Condition As String
    Dim _File As String
    Dim _Script As String
    Dim _Method As String
    Dim _Parms As String

    Public Sub New(ByVal Device As String, ByVal Condition As String, ByVal File As String, ByVal Script As String, ByVal Method As String, ByVal Parms As String)
        _Device = Device
        _Condition = Condition
        _File = File
        _Script = Script
        _Method = Method
        _Parms = Parms
    End Sub

    Public Property Device() As String
        Get
            Return _Device
        End Get
        Set(ByVal value As String)
            _Device = value
        End Set
    End Property

    Public Property Condition() As String
        Get
            Return _Condition
        End Get
        Set(ByVal value As String)
            _Condition = value
        End Set
    End Property

    Public Property File() As String
        Get
            Return _File
        End Get
        Set(ByVal value As String)
            _File = value
        End Set
    End Property

    Public Property Script() As String
        Get
            Return _Script
        End Get
        Set(ByVal value As String)
            _Script = value
        End Set
    End Property

    Public Property Method() As String
        Get
            Return _Method
        End Get
        Set(ByVal value As String)
            _Method = value
        End Set
    End Property

    Public Property Parms() As String
        Get
            Return _Parms
        End Get
        Set(ByVal value As String)
            _Parms = value
        End Set
    End Property
End Class
